-- contains all of the functions i regularly use

-- Y ORDERING

function ysort (a,b)
	return a.y<b.y
end

-- BOX COLLISIONS

-- Collision detection function.
-- Checks if box1 and box2 overlap.
-- w and h mean width and height.
function checkCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or -- Is box1 on the right side of box2?
       box1y > box2y + box2h - 1 or -- Is box1 under box2?
       box2x > box1x + box1w - 1 or -- Is box2 on the right side of box1?
       box2y > box1y + box1h - 1    -- Is b2 under b1?
    then
        return false                -- No collision. Yay!
    else
        return true                 -- Yes collision. Ouch!
    end
end

-- GAME DIRECTORY LIST

-- This function will return a string filetree of all files
-- in the folder and files in all subfolders
function recursiveEnumerate(folder, fileTree)
    local lfs = love.filesystem
    local filesTable = lfs.enumerate(folder)
    for i,v in ipairs(filesTable) do
        local file = folder.."/"..v
        if lfs.isFile(file) then
            fileTree = fileTree.."\n"..file
        elseif lfs.isDirectory(file) then
            fileTree = fileTree.."\n"..file.." (DIR)"
            fileTree = recursiveEnumerate(file, fileTree)
        end
    end
    return fileTree
end

-- call this in load to do it
-- filesString = recursiveEnumerate("", "")

-- TEST IF SOMETHING IS ALREADY IN A TABLE
-- used to see if something should be added or not

function testforsame(item,table)
	local output = false
	for i,v in ipairs(table) do
		if v == item then
			output = true
		end
	end
	return output
end
		
		
		
		
		