-- you can add windows on like this (best for on startup windows)
-- or using awolNew() to create them on the fly
awol = {
	{
		z = 0,
		coords = {0,10,300,800},
		theme = {10,20,130},
		header = "GAME",
		settings = {
			minimisable = true,
			removable = false,
			movable = true,
			resizable = true,
		},
		minimised = false,
		framebuffer = love.graphics.newFramebuffer(300,1000),
		resize = {300,1000},
		ondrag=function() print("gamedrag") end
	},
	{
		z = 0,
		coords = {300,10,300,1000},
		theme = {10,20,130},
		header = "DEBUG",
		settings = {
			minimisable = true,
			removable = false,
			movable = true,
			resizable = true,
		},
		minimised = false,
		framebuffer = love.graphics.newFramebuffer(300,1000),
		resize = {300,1000},
		ondrag=function() aDebug.drawOverlay = not aDebug.drawOverlay print("Debug active? ".. tostring(aDebug.drawOverlay)) end
	},
}

function awolDraw()
	for i = 1,#awol do
		awolWindow(awol[i],i)
	end
end


-- function for creating awol table entries
-- submit all as tables except headertext, startminimised and framebufferwindow
-- they should be submitted as true/false arguments
-- example
-- awolNew({200,200,200,200},{0,240,0},"EXAMPLE",{minimisable = true, removable = true, movable = true, resizable = true,})

function awolNew(xywh,rgb,headertext,settingsinfo,startminimised,framebufferwindow,ondrag)
	startminimised = startminimised or false
	framebufferwindow = framebufferwindow or false

	local output = {}
	output.z = 0
	output.coords = xywh
	output.theme = rgb
	output.header = headertext
	output.settings = settingsinfo
	output.minimised = startminimised
	output.ondrag = ondrag
	if framebufferwindow then
		output.framebuffer = love.graphics.newFramebuffer(output.coords[3],output.coords[4])
		output.resize = {xywh[3],xywh[4]}
	end
	table.insert(awol,output)
	output = null
end

-- basic drawing code for the windows
-- change the polygon data for different shaped tops
-- but the code is only checking for square areas of 10 by width so you cant go to crazy unless you did deeper and modify it lots
function awolWindow(table,I)
	local x = table.coords[1]
	local y = table.coords[2]
	local width = table.coords[3]
	local height = table.coords[4]
	local theme = table.theme
	local header = table.header
	local settings = table.settings
	local minimised = table.minimised
	
	if not minimised then
		love.graphics.setColor(20,20,20)
		love.graphics.rectangle("fill",x,y,width,height)
		awolContent(header,{x,y,width,height},I)
	end
	love.graphics.setColor(theme[1],theme[2],theme[3])
	love.graphics.polygon("fill",x+5,y-10,x+width-5,y-10,x+width,y-5,x+width,y,x,y,x,y-5)
	love.graphics.setColor(theme[1]+10,theme[2]+10,theme[3]+10)
	love.graphics.polygon("line",x+5,y-10,x+width-5,y-10,x+width,y-5,x+width,y,x,y,x,y-5)
	if not minimised then
		if table.resize == null then
			love.graphics.rectangle("line",x,y,width,height)
		else
			love.graphics.rectangle("line",x,y,table.resize[1],table.resize[2])
		end
	end
	
	love.graphics.setColor(255,255,255)
	love.graphics.print(header,x+5,y-10)
	if settings.minimisable then
		love.graphics.print("~",x+width-25,y-10)
	end
	if settings.removable then
		love.graphics.print("X",x+width-10,y-10)
	end
	if settings.resizable and not minimised then
		love.graphics.setColor(theme[1]+10,theme[2]+10,theme[3]+10)
		love.graphics.polygon("fill",x+width,y+height-10,x+width,y+height,x+width-10,y+height)
		love.graphics.setColor(255,255,255)
		love.graphics.print(".",x+width-4,y+height-14)
	end
	love.graphics.setColor(255,255,255)
end

-- gets the title of the table and draws the content from that name
-- contain draw information in functions from here or within this table itself
function awolContent(title,xywh,I)
	love.graphics.setColor(255,255,255)
	if title == "Test table" then
-- 		love.graphics.setRenderTarget(awol[I].framebuffer)
-- 		--game.draw(dt,xywh)
-- 		--love.graphics.circle('fill',10,10,10)
-- 				love.graphics.printf("FRAMEBUFFER : These windows represent loevthe most basic types of windows to be acheivable with this library, they resize their content based on their size. I'm programming all of this to rely on raw code as much as possible, only thing this library will do for you is the windows and their interactions everything else is upto your coding. only other thing i want to mention right now is that im not going to be developing this fast once its at a usable level ill release the file ow_awol.lua and update it from time to time as i add stuff for my projects.", 0, 0, xywh[3], "left")
-- 
-- 		love.graphics.setRenderTarget()
-- 		love.graphics.draw(awol[I].framebuffer,xywh[1],xywh[2])
	elseif title == "GAME" then
		love.graphics.setRenderTarget(awol[I].framebuffer)
		game.draw(dt,xywh)		
		love.graphics.setRenderTarget()
		love.graphics.draw(awol[I].framebuffer,xywh[1],xywh[2])
	elseif title == "DEBUG" then
		love.graphics.setRenderTarget(awol[I].framebuffer)
		debugoverlay(xywh[3])	
		love.graphics.setRenderTarget()
		love.graphics.draw(awol[I].framebuffer,xywh[1],xywh[2])
	elseif title == "MAIN.LUA" then
		
		love.graphics.printf(love.filesystem.read("main.lua"), xywh[1], xywh[2], xywh[3], "left")
		
	end
end

-- This lower code just deals with the mouse detection on the window and the window edges
awolI = {
	window = 0,
	pos = {},
	offset = {},
}

function awol.mousepressed(x,y,button)
	if button == "l" then
		if awolMouseCollider(x,y,2) ~= null then
			for i = 1,#awol do
				awol[i].z = 0
			end
			awol[awolMouseCollider(x,y,2)].z = 1
			table.sort(awol,awolSort)
		end
		if awolMouseCollider(x,y) ~= null then
			awolI.window = awolMouseCollider(x,y)
awol[awolI.window].ondrag()
			awolI.pos = {awol[awolI.window].coords[1],awol[awolI.window].coords[2]}
			awolI.offset = {x-awolI.pos[1],y-awolI.pos[2]}
			if awolCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-25,awolI.pos[2]-10,25,10) then
				if awolCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-25,awolI.pos[2]-10,10,10) then
					if not awol[awolI.window].minimised then
						awol[awolI.window].minimised = true
					else
						awol[awolI.window].minimised = false
					end
				elseif awolCollision(x,y,1,1,(awolI.pos[1]+awol[awolI.window].coords[3])-10,awolI.pos[2]-10,10,10) then
					table.remove(awol,awolI.window)
				end
				awolI = {
					window = 0,
					pos = {},
					offset = {},
				}
			end
		elseif awolMouseCollider(x,y,1) ~= null then
			awolI.window = {awolMouseCollider(x,y,1)}
			awolI.pos = {awol[awolI.window[1]].coords[3],awol[awolI.window[1]].coords[4]}
			awolI.offset = {x-awolI.pos[1],y-awolI.pos[2]}
		end
	end
end

function awolMouseCollider(x,y,mode)
	local vx,vy,vw,vh
	local current = null
	for i,v in ipairs(awol) do
		if mode == 1 then
			vx = v.coords[1]+v.coords[3]-10
			vy = v.coords[2]+v.coords[4]-10
			vw = 10
			vh = 10
		elseif mode == 2 then
			vx = v.coords[1]
			vy = v.coords[2]-10
			vw = v.coords[3]
			vh = v.coords[4]+10
		elseif mode == null or v.minimised == true then
			vx = v.coords[1]
			vy = v.coords[2]-10
			vw = v.coords[3]
			vh = 10
		end
		
		if awolCollision(x,y,1,1,vx,vy,vw,vh) == true then
			current = i
		end
	end
	return current
end

function awolInput(dt)
	local x,y = love.mouse.getX(),love.mouse.getY()
	local awolMC_result = awolMouseCollider(x,y)
	
	if love.mouse.isDown("l") then
		if awolI.window ~= 0 then
			if type(awolI.window) == "number" then
				if awol[awolI.window].settings.movable then
					awol[awolI.window].coords[1] = x -- awolI.offset[1]
					awol[awolI.window].coords[2] = y -- awolI.offset[2]
					
					if awol[awolI.window].coords[1] < 0 then
						awol[awolI.window].coords[1] = 0
					elseif awol[awolI.window].coords[1]+awol[awolI.window].coords[3] > screenWidth then
						awol[awolI.window].coords[1] = screenWidth - awol[awolI.window].coords[3]
					end
					
					if awol[awolI.window].coords[2]-10 < 10 then
						awol[awolI.window].coords[2] = 10
					elseif awol[awolI.window].coords[2]+awol[awolI.window].coords[4] > screenHeight then
						awol[awolI.window].coords[2] = screenHeight - awol[awolI.window].coords[4]
					end
				end
			elseif type(awolI.window) == "table" then
				if awol[awolI.window[1]].settings.resizable then
					if awol[awolI.window[1]].resize == null then
						awol[awolI.window[1]].coords[3] = x - awolI.offset[1]
						awol[awolI.window[1]].coords[4] = y - awolI.offset[2]
						
						if awol[awolI.window[1]].coords[3] < font:getWidth(awol[awolI.window[1]].header) + 35 then
							awol[awolI.window[1]].coords[3] = font:getWidth(awol[awolI.window[1]].header) + 35
						end
						
						if awol[awolI.window[1]].coords[4] < 10 then
							awol[awolI.window[1]].coords[4] = 10
						end
						
					else
						awol[awolI.window[1]].resize[1] = x - awolI.offset[1]
						awol[awolI.window[1]].resize[2] = y - awolI.offset[2]
						
						if awol[awolI.window[1]].resize[1] < font:getWidth(awol[awolI.window[1]].header) + 35 then
							awol[awolI.window[1]].resize[1] = font:getWidth(awol[awolI.window[1]].header) + 35
						end
						
						if awol[awolI.window[1]].resize[2] < 10 then
							awol[awolI.window[1]].resize[2] = 10
						end
					end
				end
			end
		end
	elseif not love.mouse.isDown("l") then
		if awolI.window ~= 0 then
			if type(awolI.window) == "table" then
				if awol[awolI.window[1]].framebuffer ~= null then
					awol[awolI.window[1]].coords[3] = awol[awolI.window[1]].resize[1]
					awol[awolI.window[1]].coords[4] = awol[awolI.window[1]].resize[2]
					awol[awolI.window[1]].framebuffer = love.graphics.newFramebuffer(awol[awolI.window[1]].coords[3],awol[awolI.window[1]].coords[4])
				end
			end
			awolI = {
				window = 0,
				pos = {},
				offset = {},
			}
		end
	end
end

function awolCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
    if box1x > box2x + box2w - 1 or -- Is box1 on the right side of box2?
       box1y > box2y + box2h - 1 or -- Is box1 under box2?
       box2x > box1x + box1w - 1 or -- Is box2 on the right side of box1?
       box2y > box1y + box1h - 1    -- Is b2 under b1?
    then
        return false                -- No collision. Yay!
    else
        return true                 -- Yes collision. Ouch!
    end
end

function awolSort (a,b)
	return a.z<b.z
end