LG = love.graphics
pail = {}

rbutton = LG.newImage("roundbutton.png")
abutton = LG.newImage("arrowbutton.png")

currentbuttons = {}
touchids={}
--First, we need a generic input config

h = LG.getHeight()
w = LG.getWidth()

-- table constructor key={x,y,height,width}

function pail.update(dt)

  for i,v in ipairs(currentbuttons) do
	controls[v](dt)
  end

end

function pail.mousereleased()

  local x = love.mouse.getX()
  local y = love.mouse.getY()
  for i,v in pairs(keypad) do
    if x >= v[1] and x <= v[1]+v[3] and y >= v[2] and y <= v[2]+v[3] then
      cancelButton(i)
    end
  end
  
  
end

function pail.load()
  if love.phone then
    love.phone.enableTouchEvents()
    function love.phone.touch(action,data)
		for i=1,99,3 do 
				local id,x,y = data[i],data[i+1],data[i+2]
				if (not id) then break end
				keypadpress(x,y,id)
			end
		end    
  end
end

function keypadpress(x,y,id)
   if id then 
    if touchids[id] then 
      return 
    else 
      touchids[id] = true 
    end
  end
   for i,v in pairs(keypad) do
      if x >= v[1] and x <= v[1]+v[3] and y >= v[2] and y <= v[2]+v[3] then
	table.insert(currentbuttons,i)
      end
    end
end

function pail.mousepressed(button)
  local x = love.mouse.getX()
  local y = love.mouse.getY()
  keypadpress(x,y)
end

function pail.keypressed(button)

  if controls[button] then
    table.insert(currentbuttons,button)
  end

end

function cancelButton(button)

  for i,v in ipairs(currentbuttons) do
    if v == button then table.remove(currentbuttons,i) end
  end

end

function pail.keyreleased(button)

  cancelButton(button)

end

function pail.draw(dt)

  LG.setColor(255,255,255)
  
  for i,v in pairs(keypad) do
     --LG.rectangle("fill",v[1],v[2],v[3],v[3])
     LG.draw(rbutton,v[1],v[2],0,5)
  end
  
end

function table.set(t) -- set of list
  local u = { }
  for _, v in ipairs(t) do u[v] = true end
  return u
end

function table.find(f, l) -- find element v of l satisfying f(v)
  for _, v in ipairs(l) do
    if f(v) then
      return v
    end
  end
  return nil
end

